﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Cv6base.Domain
{
    class EnrolledCourse
    {
        public Course Course { get; set; }
        public Mark? Mark { get; set; }

        public double? MarkValue
        {
            get
            {
                if (!Mark.HasValue)
                    return null;

                switch (Mark.Value)
                {
                    case Domain.Mark.A:
                        return 1;
                    case Domain.Mark.B:
                        return 1.5;
                    case Domain.Mark.C:
                        return 2;
                    case Domain.Mark.D:
                        return 2.5;
                    case Domain.Mark.E:
                        return 3;
                    case Domain.Mark.F:
                        return 4;
                    default:
                        throw new ArgumentOutOfRangeException();
                }
            }
        }
        
        public EnrolledCourse(Course course, Mark? mark)
        {
            if (course == null)
                throw new ArgumentNullException("course");

            Course = course;
            Mark = mark;
        }

        public override string ToString()
        {
            var x = (Mark.HasValue ? Mark.Value.ToString() : "not marked");
            return Course.ToString() + ", Mark:" + x;
        }
    }
}
