﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Cv6base.Domain
{
    class Student
    {
        public int Id { get; private set; }

        public string FullName { get; private set; }

        public DateTime AdmissionDate { get; set; }

        public DateTime? TerminationDate { get; set; }

        public IList<EnrolledCourse> Courses { get; private set; }
                
        public Student(int id, string fullname, DateTime admissionDate)
        {
            if (id < 0)
                throw new ArgumentOutOfRangeException("id", id, "Student ID must be greater than or equal to zero.");
            if (fullname == null)
                throw new ArgumentNullException("fullname");
            if (string.IsNullOrWhiteSpace(fullname))
                throw new ArgumentException("Student name can't be empty nor consist only of white-space characters.", "fullname");


            Id = id;
            FullName = fullname;
            AdmissionDate = admissionDate;
            Courses = new List<EnrolledCourse>();
        }

        public void Enroll(Course course, Mark? mark = null)
        {
            Courses.Add(new EnrolledCourse(course, mark));
        }
    }
}
