﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Cv6base.Domain
{
    class University
    {
        public IList<Student> Students { get; private set; }
       

        private int nextId;

        public University()
        {
            Students = new List<Student>();
        }


        internal int Register(string fullName, DateTime admissionDate, DateTime? terminationDate, params EnrolledCourse[] courses)
        {
            int id = GetNextId();
            Student student = new Student(id, fullName, admissionDate) { TerminationDate = terminationDate };
            foreach (var enrolledCourse in courses)
            {
                student.Courses.Add(enrolledCourse);
            }
            Students.Add(student);
            return id;
        }

        private int GetNextId()
        {
            // generuje další unikátní ID, což by v praxi za moc nestálo, ale na školní demo úloze to postačí
            return ++nextId;
        }
    }
}
